/*
	js2flash-auto.as: ActionScript 2.0 SWF source of js2flash-auto
	
	js2flash-auto, automatic ExternalInterface test code for GNU Flash Player
	Copyright (C) 2015 Nutchanon Wetchasit
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import flash.external.*;

class JS2FlashAuto {
	/** Entry point */
	public static function main(mc:MovieClip):Void {

		/** Checker function, print each test result to trace() */
		var check_equals = function(op1, op2, msg):Void {
			if(op1 == op2) trace("PASSED: "+msg);
			else trace("FAILED: "+msg);
		};

		check_equals(ExternalInterface.available, true,
			"ExternalInterface should be available");

		mc.script_call = function(arg1, arg2):String {
			check_equals(true, false, "ExternalInterface-registered callback should be called");
			check_equals(arg1 === "Hello" && arg2 === "World", true,
			             "ExternalInterface should pass correct callback arguments");
			return "Too";
		};

		check_equals(
			ExternalInterface.addCallback("script_call", null,
				function(arg1, arg2):String {
					check_equals(true, true, "ExternalInterface-registered callback should be called");
					check_equals(arg1 === "Hello" && arg2 === "World", true,
					             "ExternalInterface should pass correct callback arguments");
					return "Too";
				}
			), true, "ExternalInterface registration should not fail"
		);
	}
}
